My Project: Newton Class Reference

My Project

Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
Newton Class Reference

`#include <NewtonClass.h>`

Inheritance diagram for Newton:

## Public Member Functions

| Newton (dgFloat32 scale, dgMemoryAllocator *const allocator)
| ~Newton ()
void | DestroyBody (dgBody *const body)
void | DestroyJoint (dgConstraint *const joint)
void | UpdatePhysics (dgFloat32 timestep)
void | UpdatePhysicsAsync (dgFloat32 timestep)
Public Member Functions inherited from dgWorld
| dgWorld (dgMemoryAllocator *const allocator)
| ~dgWorld ()
dgBroadPhase * | GetBroadPhase () const
void | SetSolverMode (dgInt32 mode)
void | SetFrictionMode (dgInt32 mode)
dgInt32 | EnumerateHardwareModes () const
dgInt32 | GetCurrentHardwareMode () const
void | SetCurrentHardwareMode (dgInt32 deviceIndex)
void | GetHardwareVendorString (dgInt32 deviceIndex, char *const description, dgInt32 maxlength) const
void | EnableThreadOnSingleIsland (dgInt32 mode)
dgInt32 | GetThreadOnSingleIsland () const
void | FlushCache ()
void * | GetUserData () const
void | SetUserData (void *const userData)
void | Update (dgFloat32 timestep)
void | UpdateAsync (dgFloat32 timestep)
void | StepDynamics (dgFloat32 timestep)
dgInt32 | Collide (const dgCollisionInstance *const collisionA, const dgMatrix &matrixA, const dgCollisionInstance *const collisionB, const dgMatrix &matrixB, dgTriplex *const points, dgTriplex *const normals, dgFloat32 *const penetration, dgInt64 *const attibuteA, dgInt64 *const attibuteB, dgInt32 maxContacts, dgInt32 threadIndex)
dgInt32 | CollideContinue (const dgCollisionInstance *const collisionA, const dgMatrix &matrixA, const dgVector &velocA, const dgVector &omegaA, const dgCollisionInstance *const collisionB, const dgMatrix &matrixB, const dgVector &velocB, const dgVector &omegaB, dgFloat32 &timeStep, dgTriplex *const points, dgTriplex *const normals, dgFloat32 *const penetration, dgInt64 *const attibuteA, dgInt64 *const attibuteB, dgInt32 maxContacts, dgInt32 threadIndex)
bool | IntersectionTest (const dgCollisionInstance *const collisionA, const dgMatrix &matrixA, const dgCollisionInstance *const collisionB, const dgMatrix &matrixB, dgInt32 threadIndex)
dgInt32 | ClosestPoint (dgTriplex &point, const dgCollisionInstance *const collision, const dgMatrix &matrix, dgTriplex &contact, dgTriplex &normal, dgInt32 threadIndex)
dgInt32 | ClosestPoint (const dgCollisionInstance *const collisionA, const dgMatrix &matrixA, const dgCollisionInstance *const collisionB, const dgMatrix &matrixB, dgTriplex &contactA, dgTriplex &contactB, dgTriplex &normalAB, dgInt32 threadIndex)
void | SetFrictionThreshold (dgFloat32 acceletion)
dgBody * | GetIslandBody (const void *const island, dgInt32 index) const
void * | GetListenerUserData (void *const listener) const
void * | FindPreListener (const char *const nameid) const
void * | FindPostListener (const char *const nameid) const
void * | AddPreListener (const char *const nameid, void *const userData, OnListenerUpdateCallback updateCallback, OnListenerDestroyCallback destroyCallback)
void * | AddPostListener (const char *const nameid, void *const userData, OnListenerUpdateCallback updateCallback, OnListenerDestroyCallback destroyCallback)
void | SetListenerBodyDestroyCallback (void *const listener, OnListenerBodyDestroyCallback callback)
OnListenerBodyDestroyCallback | GetListenerBodyDestroyCallback (void *const listener) const
void | SetIslandUpdateCallback (OnIslandUpdate callback)
void | InitBody (dgBody *const body, dgCollisionInstance *const collision, const dgMatrix &matrix)
dgDynamicBody * | CreateDynamicBody (dgCollisionInstance *const collision, const dgMatrix &matrix)
dgKinematicBody * | CreateKinematicBody (dgCollisionInstance *const collision, const dgMatrix &matrix)
dgBody * | CreateDeformableBody (dgCollisionInstance *const collision, const dgMatrix &matrix)
void | DestroyBody (dgBody *const body)
void | DestroyAllBodies ()
void | BodySetMatrix (dgBody *const body, const dgMatrix &matrix)
dgInt32 | GetBodiesCount () const
dgInt32 | GetConstraintsCount () const
dgCollisionInstance * | CreateInstance (const dgCollision *const child, dgInt32 shapeID, const dgMatrix &offsetMatrix)
dgCollisionInstance * | CreateNull ()
dgCollisionInstance * | CreateSphere (dgFloat32 radiusdg, dgInt32 shapeID, const dgMatrix &offsetMatrix=dgGetIdentityMatrix())
dgCollisionInstance * | CreateCone (dgFloat32 radius, dgFloat32 height, dgInt32 shapeID, const dgMatrix &offsetMatrix=dgGetIdentityMatrix())
dgCollisionInstance * | CreateCapsule (dgFloat32 radius, dgFloat32 height, dgInt32 shapeID, const dgMatrix &offsetMatrix=dgGetIdentityMatrix())
dgCollisionInstance * | CreateCylinder (dgFloat32 radius, dgFloat32 height, dgInt32 shapeID, const dgMatrix &offsetMatrix=dgGetIdentityMatrix())
dgCollisionInstance * | CreateBox (dgFloat32 dx, dgFloat32 dy, dgFloat32 dz, dgInt32 shapeID, const dgMatrix &offsetMatrix=dgGetIdentityMatrix())
dgCollisionInstance * | CreateConvexHull (dgInt32 count, const dgFloat32 *const points, dgInt32 strideInBytes, dgFloat32 thickness, dgInt32 shapeID, const dgMatrix &offsetMatrix=dgGetIdentityMatrix())
dgCollisionInstance * | CreateTaperedCapsule (dgFloat32 radio0, dgFloat32 radio1, dgFloat32 height, dgInt32 shapeID, const dgMatrix &offsetMatrix=dgGetIdentityMatrix())
dgCollisionInstance * | CreateTaperedCylinder (dgFloat32 radio0, dgFloat32 radio1, dgFloat32 height, dgInt32 shapeID, const dgMatrix &offsetMatrix=dgGetIdentityMatrix())
dgCollisionInstance * | CreateChamferCylinder (dgFloat32 radius, dgFloat32 height, dgInt32 shapeID, const dgMatrix &offsetMatrix=dgGetIdentityMatrix())
dgCollisionInstance * | CreateCompound ()
dgCollisionInstance * | CreateFracturedCompound (dgMeshEffect *const solidMesh, int shapeID, int fracturePhysicsMaterialID, int pointcloudCount, const dgFloat32 *const vertexCloud, int strideInBytes, int materialID, const dgMatrix &textureMatrix, dgCollisionCompoundFractured::OnEmitFractureChunkCallBack emitFrafuredChunk, dgCollisionCompoundFractured::OnEmitNewCompundFractureCallBack emitFracturedCompound, dgCollisionCompoundFractured::OnReconstructFractureMainMeshCallBack reconstructMainMesh)
dgCollisionInstance * | CreateDeformableMesh (dgMeshEffect *const mesh, dgInt32 shapeID)
dgCollisionInstance * | CreateClothPatchMesh (dgMeshEffect *const mesh, dgInt32 shapeID, const dgClothPatchMaterial &structuralMaterial, const dgClothPatchMaterial &bendMaterial)
dgCollisionInstance * | CreateBVH ()
dgCollisionInstance * | CreateStaticUserMesh (const dgVector &boxP0, const dgVector &boxP1, const dgUserMeshCreation &data)
dgCollisionInstance * | CreateHeightField (dgInt32 width, dgInt32 height, dgInt32 contructionMode, dgInt32 elevationDataType, const void *const elevationMap, const dgInt8 *const atributeMap, dgFloat32 verticalScale, dgFloat32 horizontalScale)
dgCollisionInstance * | CreateScene ()
void | SetCollisionInstanceConstructorDestructor (OnCollisionInstanceDuplicate constructor, OnCollisionInstanceDestroy destructor)
void | SerializeToFile (const char *const fileName) const
void | SerializeBodyArray (dgBody **const array, dgInt32 count, OnBodySerialize bodyCallback, dgSerialize serializeCallback, void *const userData) const
void | DeserializeBodyArray (OnBodyDeserialize bodyCallback, dgDeserialize deserializeCallback, void *const userData)
void | SerializeCollision (dgCollisionInstance *const shape, dgSerialize deserialization, void *const userData) const
dgCollisionInstance * | CreateCollisionFromSerialization (dgDeserialize deserialization, void *const userData)
void | ReleaseCollision (const dgCollision *const collision)
dgUpVectorConstraint * | CreateUpVectorConstraint (const dgVector &pin, dgBody *body)
dgBallConstraint * | CreateBallConstraint (const dgVector &pivot, dgBody *const body0, dgBody *refBody=NULL)
dgHingeConstraint * | CreateHingeConstraint (const dgVector &pivot, const dgVector &pin, dgBody *const body0, dgBody *refBody=NULL)
dgSlidingConstraint * | CreateSlidingConstraint (const dgVector &pivot, const dgVector &pin, dgBody *const body0, dgBody *refBody=NULL)
dgCorkscrewConstraint * | CreateCorkscrewConstraint (const dgVector &pivot, const dgVector &pin, dgBody *const body0, dgBody *refBody=NULL)
dgUniversalConstraint * | CreateUniversalConstraint (const dgVector &pivot, const dgVector &pin0, const dgVector &pin1, dgBody *const body0, dgBody *body1=NULL)
void | DestroyConstraint (dgConstraint *constraint)
dgUnsigned32 | CreateBodyGroupID ()
void | RemoveAllGroupID ()
dgUnsigned32 | GetDefualtBodyGroupID () const
dgContactMaterial * | GetMaterial (dgUnsigned32 bodyGroupId0, dgUnsigned32 bodyGroupId1) const
dgContactMaterial * | GetFirstMaterial () const
dgContactMaterial * | GetNextMaterial (dgContactMaterial *material) const
OnGetPerformanceCountCallback | GetPerformaceFuntion () const
void | SetPerfomanceCounter (OnGetPerformanceCountCallback callback)
void | SetThreadsCount (dgInt32 count)
dgUnsigned32 | GetPerfomanceTicks (dgUnsigned32 entry) const
dgUnsigned32 | GetThreadPerfomanceTicks (dgUnsigned32 threadIndex) const
void | ExecuteUserJob (dgWorkerThreadTaskCallback userJobKernel, void *const userJobKernelContext)
void | BodyEnableSimulation (dgBody *const body)
void | BodyDisableSimulation (dgBody *const body)
bool | GetBodyEnableDisableSimulationState (dgBody *const body) const
dgBody * | GetSentinelBody () const
dgMemoryAllocator * | GetAllocator () const
dgFloat32 | GetContactMergeTolerance () const
void | SetContactMergeTolerance (dgFloat32 tolerenace)
void | Sync ()
Public Member Functions inherited from dgBodyMasterList
| dgBodyMasterList (dgMemoryAllocator *const allocator)
| ~dgBodyMasterList ()
void | AddBody (dgBody *const body)
void | RemoveBody (dgBody *const body)
void | RemoveConstraint (dgConstraint *const constraint)
void | AttachConstraint (dgConstraint *const constraint, dgBody *const body0, dgBody *const body1)
dgBodyMasterListRow::dgListNode * | FindConstraintLink (const dgBody *const body0, const dgBody *const body1) const
dgBodyMasterListRow::dgListNode * | FindConstraintLinkNext (const dgBodyMasterListRow::dgListNode *const me, const dgBody *const body) const
dgUnsigned32 | MakeSortMask (const dgBody *const body) const
void | SortMasterList ()
Public Member Functions inherited from dgList< dgBodyMasterListRow >
| dgList (dgMemoryAllocator *const allocator)
virtual | ~dgList ()
dgMemoryAllocator * | GetAllocator () const
void | SetAllocator (dgMemoryAllocator *const allocator)
| operator dgInt32 () const
dgInt32 | GetCount () const
dgListNode * | GetLast () const
dgListNode * | GetFirst () const
dgListNode * | Append ()
dgListNode * | Append (dgListNode *const node)
dgListNode * | Append (const dgBodyMasterListRow &element)
dgListNode * | Addtop ()
dgListNode * | Addtop (dgListNode *const node)
dgListNode * | Addtop (const dgBodyMasterListRow &element)
void | RotateToEnd (dgListNode *const node)
void | RotateToBegin (dgListNode *const node)
void | InsertAfter (dgListNode *const root, dgListNode *const node)
void | InsertBefore (dgListNode *const root, dgListNode *const node)
dgListNode * | Find (const dgBodyMasterListRow &element) const
dgListNode * | GetNodeFromInfo (dgBodyMasterListRow &m_info) const
void | Remove (dgListNode *const node)
void | Remove (const dgBodyMasterListRow &element)
void | RemoveAll ()
void | Merge (dgList< dgBodyMasterListRow > &list)
void | Unlink (dgListNode *const node)
bool | SanityCheck () const
Public Member Functions inherited from dgBodyMaterialList
| dgBodyMaterialList (dgMemoryAllocator *const allocator)
Public Member Functions inherited from dgTree< dgContactMaterial, dgUnsigned32 >
| dgTree (dgMemoryAllocator *const allocator)
virtual | ~dgTree ()
dgMemoryAllocator * | GetAllocator () const
void | SetAllocator (dgMemoryAllocator *const allocator)
| operator dgInt32 () const
dgInt32 | GetCount () const
dgTreeNode * | GetRoot () const
dgTreeNode * | Minimum () const
dgTreeNode * | Maximum () const
dgTreeNode * | Find (dgUnsigned32 key) const
dgTreeNode * | FindGreater (dgUnsigned32 key) const
dgTreeNode * | FindGreaterEqual (dgUnsigned32 key) const
dgTreeNode * | FindLessEqual (dgUnsigned32 key) const
dgTreeNode * | GetNodeFromInfo (dgContactMaterial &info) const
dgTreeNode * | Insert (const dgContactMaterial &element, dgUnsigned32 key, bool &elementWasInTree)
dgTreeNode * | Insert (const dgContactMaterial &element, dgUnsigned32 key)
dgTreeNode * | Insert (dgTreeNode *const node, dgUnsigned32 key)
dgTreeNode * | Replace (dgContactMaterial &element, dgUnsigned32 key)
dgTreeNode * | ReplaceKey (dgUnsigned32 oldKey, dgUnsigned32 newKey)
dgTreeNode * | ReplaceKey (dgTreeNode *const node, dgUnsigned32 key)
void | Remove (dgUnsigned32 key)
void | Remove (dgTreeNode *const node)
void | RemoveAll ()
void | Unlink (dgTreeNode *const node)
void | SwapInfo (dgTree &tree)
bool | SanityCheck () const
Public Member Functions inherited from dgBodyCollisionList
| dgBodyCollisionList (dgMemoryAllocator *const allocator)
Public Member Functions inherited from dgTree< const dgCollision *, dgUnsigned32 >
| dgTree (dgMemoryAllocator *const allocator)
virtual | ~dgTree ()
dgMemoryAllocator * | GetAllocator () const
void | SetAllocator (dgMemoryAllocator *const allocator)
| operator dgInt32 () const
dgInt32 | GetCount () const
dgTreeNode * | GetRoot () const
dgTreeNode * | Minimum () const
dgTreeNode * | Maximum () const
dgTreeNode * | Find (dgUnsigned32 key) const
dgTreeNode * | FindGreater (dgUnsigned32 key) const
dgTreeNode * | FindGreaterEqual (dgUnsigned32 key) const
dgTreeNode * | FindLessEqual (dgUnsigned32 key) const
dgTreeNode * | GetNodeFromInfo (const dgCollision * &info) const
dgTreeNode * | Insert (const const dgCollision * &element, dgUnsigned32 key, bool &elementWasInTree)
dgTreeNode * | Insert (const const dgCollision * &element, dgUnsigned32 key)
dgTreeNode * | Insert (dgTreeNode *const node, dgUnsigned32 key)
dgTreeNode * | Replace (const dgCollision * &element, dgUnsigned32 key)
dgTreeNode * | ReplaceKey (dgUnsigned32 oldKey, dgUnsigned32 newKey)
dgTreeNode * | ReplaceKey (dgTreeNode *const node, dgUnsigned32 key)
void | Remove (dgUnsigned32 key)
void | Remove (dgTreeNode *const node)
void | RemoveAll ()
void | Unlink (dgTreeNode *const node)
void | SwapInfo (dgTree &tree)
bool | SanityCheck () const
Public Member Functions inherited from dgDeformableBodiesUpdate
| dgDeformableBodiesUpdate (dgMemoryAllocator *const allocator)
void | AddShape (dgCollisionDeformableMesh *const shape)
void | RemoveShape (dgCollisionDeformableMesh *const shape)
Public Member Functions inherited from dgList< dgCollisionDeformableMesh *>
| dgList (dgMemoryAllocator *const allocator)
virtual | ~dgList ()
dgMemoryAllocator * | GetAllocator () const
void | SetAllocator (dgMemoryAllocator *const allocator)
| operator dgInt32 () const
dgInt32 | GetCount () const
dgListNode * | GetLast () const
dgListNode * | GetFirst () const
dgListNode * | Append ()
dgListNode * | Append (dgListNode *const node)
dgListNode * | Append (const dgCollisionDeformableMesh * &element)
dgListNode * | Addtop ()
dgListNode * | Addtop (dgListNode *const node)
dgListNode * | Addtop (const dgCollisionDeformableMesh * &element)
void | RotateToEnd (dgListNode *const node)
void | RotateToBegin (dgListNode *const node)
void | InsertAfter (dgListNode *const root, dgListNode *const node)
void | InsertBefore (dgListNode *const root, dgListNode *const node)
dgListNode * | Find (const dgCollisionDeformableMesh * &element) const
dgListNode * | GetNodeFromInfo (dgCollisionDeformableMesh * &m_info) const
void | Remove (dgListNode *const node)
void | Remove (const dgCollisionDeformableMesh * &element)
void | RemoveAll ()
void | Merge (dgList< dgCollisionDeformableMesh * > &list)
void | Unlink (dgListNode *const node)
bool | SanityCheck () const
Public Member Functions inherited from dgActiveContacts
| dgActiveContacts (dgMemoryAllocator *const allocator)
Public Member Functions inherited from dgList< dgContact *>
| dgList (dgMemoryAllocator *const allocator)
virtual | ~dgList ()
dgMemoryAllocator * | GetAllocator () const
void | SetAllocator (dgMemoryAllocator *const allocator)
| operator dgInt32 () const
dgInt32 | GetCount () const
dgListNode * | GetLast () const
dgListNode * | GetFirst () const
dgListNode * | Append ()
dgListNode * | Append (dgListNode *const node)
dgListNode * | Append (const dgContact * &element)
dgListNode * | Addtop ()
dgListNode * | Addtop (dgListNode *const node)
dgListNode * | Addtop (const dgContact * &element)
void | RotateToEnd (dgListNode *const node)
void | RotateToBegin (dgListNode *const node)
void | InsertAfter (dgListNode *const root, dgListNode *const node)
void | InsertBefore (dgListNode *const root, dgListNode *const node)
dgListNode * | Find (const dgContact * &element) const
dgListNode * | GetNodeFromInfo (dgContact * &m_info) const
void | Remove (dgListNode *const node)
void | Remove (const dgContact * &element)
void | RemoveAll ()
void | Merge (dgList< dgContact * > &list)
void | Unlink (dgListNode *const node)
bool | SanityCheck () const
Public Member Functions inherited from dgCollidingPairCollector
| dgCollidingPairCollector ()
| ~dgCollidingPairCollector ()
void | Init ()
void | AddPair (dgContact *const contatJoint, dgInt32 threadIndex)
Public Member Functions inherited from dgMutexThread
| dgMutexThread (const char *const name, dgInt32 id)
virtual | ~dgMutexThread (void)
void | Tick ()
void | Terminate ()
bool | IsBusy () const
Public Member Functions inherited from dgThread
| dgThread ()
| dgThread (const char *const name, dgInt32 id)
virtual | ~dgThread ()
bool | StillBusy () const
void | SuspendExecution (dgSemaphore &mutex)
void | SuspendExecution (dgInt32 count, dgSemaphore *const mutexes)
dgInt32 | GetPriority () const
void | SetPriority (int priority)
Public Member Functions inherited from dgAsyncThread
| dgAsyncThread (const char *const name, dgInt32 id)
virtual | ~dgAsyncThread (void)
void | Tick ()
void | Terminate ()
Public Member Functions inherited from dgWorldThreadPool
| dgWorldThreadPool (dgMemoryAllocator *const allocator)
virtual void | OnBeginWorkerThread (dgInt32 threadId)
virtual void | OnEndWorkerThread (dgInt32 threadId)
Public Member Functions inherited from dgThreadHive
| dgThreadHive (dgMemoryAllocator *const allocator)
virtual | ~dgThreadHive ()
void | SetMatertThread (dgThread *const mastertThread)
void | GlobalLock () const
void | GlobalUnlock () const
void | GetIndirectLock (dgThread::dgCriticalSection *const criticalSectionLock) const
void | ReleaseIndirectLock (dgThread::dgCriticalSection *const criticalSectionLock) const
void | ClearTimers ()
dgInt32 | GetThreadCount () const
dgInt32 | GetMaxThreadCount () const
void | SetThreadsCount (dgInt32 count)
void | QueueJob (dgWorkerThreadTaskCallback callback, void *const context0, void *const context1)
void | SynchronizationBarrier ()
void | SetPerfomanceCounter (OnGetPerformanceCountCallback callback)
dgUnsigned32 | GetPerfomanceTicks (dgUnsigned32 threadIndex) const
Public Member Functions inherited from NewtonDeadBodies
| NewtonDeadBodies (dgMemoryAllocator *const allocator)
void | DestroyBodies (Newton &world)
Public Member Functions inherited from dgTree< dgBody *, void * >
| dgTree (dgMemoryAllocator *const allocator)
virtual | ~dgTree ()
dgMemoryAllocator * | GetAllocator () const
void | SetAllocator (dgMemoryAllocator *const allocator)
| operator dgInt32 () const
dgInt32 | GetCount () const
dgTreeNode * | GetRoot () const
dgTreeNode * | Minimum () const
dgTreeNode * | Maximum () const
dgTreeNode * | Find (void * key) const
dgTreeNode * | FindGreater (void * key) const
dgTreeNode * | FindGreaterEqual (void * key) const
dgTreeNode * | FindLessEqual (void * key) const
dgTreeNode * | GetNodeFromInfo (dgBody * &info) const
dgTreeNode * | Insert (const dgBody * &element, void * key, bool &elementWasInTree)
dgTreeNode * | Insert (const dgBody * &element, void * key)
dgTreeNode * | Insert (dgTreeNode *const node, void * key)
dgTreeNode * | Replace (dgBody * &element, void * key)
dgTreeNode * | ReplaceKey (void * oldKey, void * newKey)
dgTreeNode * | ReplaceKey (dgTreeNode *const node, void * key)
void | Remove (void * key)
void | Remove (dgTreeNode *const node)
void | RemoveAll ()
void | Unlink (dgTreeNode *const node)
void | SwapInfo (dgTree &tree)
bool | SanityCheck () const
Public Member Functions inherited from NewtonDeadJoints
| NewtonDeadJoints (dgMemoryAllocator *const allocator)
void | DestroyJoints (Newton &world)
Public Member Functions inherited from dgTree< dgConstraint *, void * >
| dgTree (dgMemoryAllocator *const allocator)
virtual | ~dgTree ()
dgMemoryAllocator * | GetAllocator () const
void | SetAllocator (dgMemoryAllocator *const allocator)
| operator dgInt32 () const
dgInt32 | GetCount () const
dgTreeNode * | GetRoot () const
dgTreeNode * | Minimum () const
dgTreeNode * | Maximum () const
dgTreeNode * | Find (void * key) const
dgTreeNode * | FindGreater (void * key) const
dgTreeNode * | FindGreaterEqual (void * key) const
dgTreeNode * | FindLessEqual (void * key) const
dgTreeNode * | GetNodeFromInfo (dgConstraint * &info) const
dgTreeNode * | Insert (const dgConstraint * &element, void * key, bool &elementWasInTree)
dgTreeNode * | Insert (const dgConstraint * &element, void * key)
dgTreeNode * | Insert (dgTreeNode *const node, void * key)
dgTreeNode * | Replace (dgConstraint * &element, void * key)
dgTreeNode * | ReplaceKey (void * oldKey, void * newKey)
dgTreeNode * | ReplaceKey (dgTreeNode *const node, void * key)
void | Remove (void * key)
void | Remove (dgTreeNode *const node)
void | RemoveAll ()
void | Unlink (dgTreeNode *const node)
void | SwapInfo (dgTree &tree)
bool | SanityCheck () const

## Static Public Member Functions

static void * | DefaultAllocMemory (dgInt32 size)
static void | DefaultFreeMemory (void *const ptr, dgInt32 size)
Static Public Member Functions inherited from dgWorld
static void | OnSerializeToFile (void *const userData, const void *const buffer, size_t size)
static void | OnBodySerializeToFile (dgBody &body, dgSerialize serializeCallback, void *const userData)

## Public Attributes

dgFloat32 | m_maxTimeStep
NewtonWorldDestructorCallback | m_destructor
Public Attributes inherited from dgBodyMasterList
dgTree< int, dgBody * > | m_disableBodies
dgInt32 | m_deformableCount
dgUnsigned32 | m_constraintCount
Public Attributes inherited from dgCollidingPairCollector
dgInt32 | m_count
dgInt32 | m_maxSize
dgBody * | m_sentinel
dgThread::dgCriticalSection | m_lock

## Additional Inherited Members

Public Types inherited from dgWorld
typedef dgUnsigned32(dgApi * | OnIslandUpdate) (const dgWorld *const world, void *island, dgInt32 bodyCount)
typedef void(dgApi * | OnListenerBodyDestroyCallback) (const dgWorld *const world, void *const listener, dgBody *const body)
typedef void(dgApi * | OnListenerUpdateCallback) (const dgWorld *const world, void *const listener, dgFloat32 timestep)
typedef void(dgApi * | OnListenerDestroyCallback) (const dgWorld *const world, void *const listener)
typedef void(dgApi * | OnBodySerialize) (dgBody &me, dgSerialize funt, void *const serilalizeObject)
typedef void(dgApi * | OnBodyDeserialize) (dgBody &me, dgDeserialize funt, void *const serilalizeObject)
typedef void(dgApi * | OnCollisionInstanceDestroy) (const dgWorld *const world, const dgCollisionInstance *const collision)
typedef void(dgApi * | OnCollisionInstanceDuplicate) (const dgWorld *const world, dgCollisionInstance *const collision, const dgCollisionInstance *const sourceCollision)
Protected Member Functions inherited from dgThread
void | Init ()
void | Init (const char *const name, dgInt32 id)
void | Close ()
Static Protected Member Functions inherited from dgThread
static void * | dgThreadSystemCallback (void *threadData)
Protected Attributes inherited from dgThread
pthread_t | m_handle
dgInt32 | m_id
dgInt32 | m_terminate
dgInt32 | m_threadRunning
char | m_name [32]

## Constructor & Destructor Documentation

## § Newton()

Newton::Newton | ( | dgFloat32 | scale,
|  | dgMemoryAllocator *const | allocator
| ) |  |

## § ~Newton()

Newton::~Newton | ( |  | ) |

## Member Function Documentation

## § DefaultAllocMemory()

void * Newton::DefaultAllocMemory | ( | dgInt32 | size | ) |

static

## § DefaultFreeMemory()

void Newton::DefaultFreeMemory | ( | void *const | ptr,
|  | dgInt32 | size
| ) |  |

static

## § DestroyBody()

void Newton::DestroyBody | ( | dgBody *const | body | ) |

## § DestroyJoint()

void Newton::DestroyJoint | ( | dgConstraint *const | joint | ) |

## § UpdatePhysics()

void Newton::UpdatePhysics | ( | dgFloat32 | timestep | ) |

## § UpdatePhysicsAsync()

void Newton::UpdatePhysicsAsync | ( | dgFloat32 | timestep | ) |

## Member Data Documentation

## § m_destructor

NewtonWorldDestructorCallback Newton::m_destructor

## § m_maxTimeStep

dgFloat32 Newton::m_maxTimeStep

The documentation for this class was generated from the following files:

- dynamics.mod/NewtonDynamics/source/newton/NewtonClass.h
- dynamics.mod/NewtonDynamics/source/newton/NewtonClass.cpp